<template>
  <form @submit="onSubmit">
    <TextField
      id="username"
      class="field"
      v-model="username"
      :error="usernameError"
      label="نام کاربری"
    />
    <TextField
      inputType="password"
      class="field"
      id="password"
      v-model="password"
      :error="passwordError"
      label="رمز عبور"
    />
    <TextField
      class="field"
      inputType="password"
      id="password-confirmation"
      v-model="passwordConfirmation"
      :error="passwordConfirmationError"
      label="تکرار رمز عبور"
    />
    <Button class="submit" type="contained" size="lg" color="primary" @click="onSubmit">ثبت نام</Button>
    <nuxt-link to="/login" class="login" v-ripple>
      <p class="login__text">قبلا ثبت نام کرده اید؟</p>
    </nuxt-link>
  </form>
</template>

<script>
import Button from "@/components/base/Button";
import TextField from "@/components/base/TextField";

export default {
  name: "SignupForm",
  components: {
    Button,
    TextField
  },
  data() {
    return {
      username: "",
      password: "",
      passwordConfirmation: "",
      waitingForResponse: false
    };
  },
  methods: {
    onSubmit(e) {
      e.preventDefault();
      if (this.canSendRegisterRequest) {
        this.$store.dispatch("auth/register", {
          username: this.username, 
          password: this.password, 
          passwordConfirmation: this.passwordConfirmation
        }).then(response => {
          this.$store.dispatch('notifications/push', {
            message: 'ثبت نام با موفقیت انجام شد!',
            type: 'success',
            light: true
          });
          this.$emit('success');
        }).catch(err => {
          if (err.response.status === 400) {
            this.$store.dispatch('notifications/push', {
              message: 'نام کاربری قبلا در سیستم ثبت شده است!',
              type: 'error'
            });
          } else {
            this.$store.dispatch('notifications/push', {
              message: 'خطا در اتصال به سرور! لطفا دقایقی دیگر دوباره تلاش کنید.',
              type: 'error',
              timeout: 3500
            });
          }
        });
      } else {
        this.$store.dispatch('notifications/push', {
          message: 'ورودی ها خود را کنترل کنید!',
          type: 'warning',
          light: true
        });
      }
    }
  },
  computed: {
    usernameError() {
      const regex = /^[A-Za-z0-9_-]{3,16}$/;
      if (this.username.length === 0) {
        return ""
      } else if (this.username.length < 3) {
        return "نام کاربری باید حداقل 3 کاراکتر باشد."  
      } else if (this.username.length > 16) {
        return "نام کاربری نمی تواند بیشتر از 16 کاراکتر باشد."
      } else if (regex.test(this.username)) {
        return ""      
      }
      return "فقط می توانید از حروف انگلیسی، عدد ، - ، _ استفاده کنید."
    },
    passwordError() {
      if (this.password.length < 5 && this.password.length !== 0) {
        return "رمز عبور باید حداقل 5 کاراکتر باشد."
      }
      return ""
    },
    passwordConfirmationError() {
      if (this.passwordConfirmation !== this.password && this.passwordConfirmation.length > 0) {
        return "رمز عبور وارد شده با قبلی تطابق ندارد.";
      }
      return ""
    },
    canSendRegisterRequest() {
      return !this.waitingForResponse &&
        this.areFormInputsValid &&
        this.isFormFilled
        ? true
        : false;
    },
    areFormInputsValid() {
      return this.usernameError ||
        this.passwordError ||
        this.passwordConfirmationError
        ? false
        : true;
    },
    isFormFilled() {
      return this.username &&
        this.password &&
        this.passwordConfirmation
        ? true
        : false;
    }
  }
};
</script>

<style lang="stylus" scoped>
@import '~assets/styles/variables';

form
  display flex
  flex-direction column

.field
  &:not(:last-child)
    margin-bottom $md

.login
  width max-content
  padding $sm 0
  align-self flex-end

.submit 
  margin-bottom $sm
</style>